/**
 * product.h
 *
 * Copyright (c) 2011 Daniel Berenguer <dberenguer@usapiens.com>
 * 
 * This file is part of the panStamp project.
 * 
 * panStamp  is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 * 
 * panStamp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with panStamp; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 
 * USA
 * 
 * Author: Daniel Berenguer
 * Creation date: 03/31/2011
 */

#ifndef _PRODUCT_H
#define _PRODUCT_H

#include "config.h"

/**
 * Hardware version
 */
#define HARDWARE_BASE              0x00000100

#ifdef ENABLE_BRIGHTNESS
#  define HARDWARE_BRIGHTNESS            0x01
#else
#  define HARDWARE_BRIGHTNESS            0x00
#endif
#ifdef ENABLE_IR
#  define HARDWARE_IR                    0x02
#else
#  define HARDWARE_IR                    0x00
#endif
#ifdef ENABLE_DMX
#  define HARDWARE_DMX                   0x04
#else
#  define HARDWARE_DMX                   0x00
#endif

#define HARDWARE_VERSION         ( HARDWARE_BASE | HARDWARE_DMX | HARDWARE_IR | HARDWARE_BRIGHTNESS )

/**
 * Firmware version
 */
#define FIRMWARE_VERSION         0x00000101

/**
 * Manufacturer SWAP ID
 */
#define SWAP_MANUFACT_ID        0x00000022

/**
 * Product SWAP ID
 */
#define SWAP_PRODUCT_ID         0x00000003

#endif

